<template>
  <section class="dropdown-wrapper">
    <div @click="isVisible = !isVisible" class="selected-item">
      <span v-if="selectedItem.length == 1">{{ selectedItem[0].title }}</span>
      <span v-else>Select {{ title }}</span>
      <drop-down-icon />
    </div>
    <div v-if="isVisible" class="dropdown-popover">  
        <form-input
          :updateValue="updateSearchQuery"
          :type="'text'"
          :value="searchQuery"
          placeholder="Search"
          :getErrors="getErrors"
          v-if="searchInput"
        />
        <p v-if="numberErrors" class="error-msg">{{ numberErrors }}</p>
      <div class="options">
        <ul>
          <li
            class="options"
            :class="{ selected: selectedItem.find(element => element.title == item.title) }"
            @click="selectItem(item), (isVisible = false)"
            v-for="(item, index) in data"
            :key="'item-${index}'"
          >
            {{ item.title }}
          </li>
          <li v-if="nextPage != null">
            <custom-button :submit="getMore" :title="'load more'" class="load-more-btn">
            </custom-button>
          </li>
        </ul>
      </div>
    </div>
  </section>
</template>
<script>

export default {
  props: {
    url: String,
    data: Array,
    title: String,
    selectedItem: Array,
    nextPage: String,
    getSearchData: Function,
    getMoreData: Function,
    selectItem: Function,
    searchInput: Boolean
  },
  data() {
    return {
      isVisible: false,
      searchQuery: "",
      numberErrors: null,
    };
  },
  methods: {
    getMore() {
      this.getMoreData(this.nextPage, true, this.searchQuery);
    },
    updateSearchQuery(searchQuery) {
      this.searchQuery = searchQuery;
      this.getSearchData(this.url, false, this.searchQuery);
    },
    getErrors(value) {
      this.numberErrors = value;
    },
  },
};
</script>
